<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>COMMENT LIST</title>
</head>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gBASE_URL = "https://jsonplaceholder.typicode.com";

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function() {
        // hiệu chỉnh căn giữa cho table head
        $("thead th").addClass("text-center align-middle");
        // gán sự kiện click button Get Comment
        $("#btn-get-comment").click(onBtnGetCommentClick);
        // gán sự kiện click button Detail
        $("#table-comment").on("click", ".btn-detail", onBtnDetailClick);
    })
    
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // function xử lý sự kiện click button Get Comment
    function onBtnGetCommentClick() {
        // B1: Thu thập dữ liệu
        let vPostId = getPostId();
        console.log("%cPOST ID: " + vPostId, "color: green");
        // B2: Kiểm tra dữ liệu
        let vDataValid = checkPostId(vPostId);
        if (vDataValid) {
            // B3: Gọi API lấy danh sách comment theo Post ID
            let vAjaxRequest = callApiGetCommentByPostId(vPostId);
            vAjaxRequest.done(function(vResponse) {
                if (vResponse.length !== 0) {
                    // B4: Xử lý hiển thị
                    console.log("Response Object:");
                    console.log(vResponse);
                    loadCommentDataToTable(vResponse);
                }
                // nếu reponse là object rỗng thì báo Post ID không tồn tại
                else {
                    alert("Post ID = " + vPostId + " not exist");
                }

            })
            vAjaxRequest.fail(function(vResponse) {
                console.log("Load data not successful");
                alert(vResponse.responseText);
            })
        }
    }

    // function xử lý sự kiện click button Detail
    function onBtnDetailClick() {
        let vCommentId = $(this).data("comment-id");
        let vUrl = "commentDetail.html?id=" + vCommentId;
        window.location.href = vUrl;
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // function thu thập dữ liệu Post Id
    // function trả về dữ liệu post ID người dùng nhập trên form
    function getPostId() {
        let vPostId = $("#inp-post-id").val().trim();
        return vPostId;
    }

    // function kiểm tra dữ liệu
    // function return true nếu tất cả dữ liệu hợp lệ, return false nếu có dữ liệu không hợp lệ
    function checkPostId(paramPostId) {
        if (paramPostId === "") {
            alert("Please enter Post ID");
            return false;
        }
        return true;
    }

    // function gọi API lấy danh sách comment theo Post ID
    function callApiGetCommentByPostId(paramPostId) {
        let vAjaxRequest = $.ajax({
            url: gBASE_URL + "/posts/" + paramPostId + "/comments/",
            type: "GET",
        });
        return vAjaxRequest;
    }

    // function load danh sách comment vào table
    function loadCommentDataToTable(paramCommentList) {
        // reset table data
        $("#table-comment tbody").html("");
        // load load danh sách comment vào table
        for (let bCommentData of paramCommentList) {
            // tạo dòng mới ở tbody
            let vNewRow = $("<tr>").appendTo($("#table-comment tbody"));
            // thêm data tương ứng vào dòng mới
            vNewRow.append(
                $("<td>").html(bCommentData.id),           // cell Comment ID
                $("<td>").html(bCommentData.email),        // cell Email           
                $("<td>").html(bCommentData.name),         // cell Title
                $("<td>").html(bCommentData.body),         // cell Content
                $("<td>")       // thêm và xử lý button Chi Tiết
                    .append($("<button>")
                        .html("Detail")
                        .addClass("btn btn-success btn-detail")
                        .data("comment-id", bCommentData.id)
                    )
            )
        }
        // hiệu chỉnh align middle cho table data
        $("tbody td").addClass("align-middle");
    }

</script>

<body>
    <div class="container jumbotron">
        <div class="row form-group">
            <div class="col-sm-12 text-center">
                <h3><span class="text-success border-bottom"><b>COMMENT LIST</b></span></h3>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-2">
                <label class="col-form-label"><b>Post ID:</b></label>
            </div>
            <div class="col-sm-7">
                <input id="inp-post-id" class="form-control" type="number" placeholder="Enter Post ID number to get Comment List">
            </div>
            <div class="col-sm-3">
                <button id="btn-get-comment" class="btn btn-success w-100">Get Comment List</button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">
                <table id="table-comment" class="table table-light table-bordered table-striped table-hover mt-3">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>EMAIL</th>
                            <th>TITLE</th>
                            <th>CONTENT</th>
                            <th>ACTION</th>
                        </tr>
                    </thead>
                    <tbody></tbody>
                </table>
            </div>
        </div>
    </div>
</body>
</html>